## eccodes 2.41.0

=== CMakeLists.txt ===
#
# (C) Copyright 2005- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
#
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#
###############################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#       -DCMAKE_INSTALL_PREFIX=/path/to/install
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild 3.7 HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)
if(NOT ecbuild_FOUND)
    message(STATUS "Fetching ecbuild...")
    include(FetchContent)
    FetchContent_Populate(ecbuild
        GIT_REPOSITORY https://github.com/ecmwf/ecbuild.git
        GIT_TAG        3.8.5
    )
    find_package( ecbuild 3.7 REQUIRED HINTS ${ecbuild_SOURCE_DIR})
endif()

# Initialise project
project( eccodes LANGUAGES CXX )
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)


###############################################################################
# system checks needed for eccodes_config.h and some options like MEMFS

check_type_size( int     ECCODES_SIZEOF_INT )
check_type_size( long    ECCODES_SIZEOF_LONG )
check_type_size( size_t  ECCODES_SIZEOF_SIZE_T )

check_include_files( assert.h      ECCODES_HAVE_ASSERT_H )
check_include_files( string.h      ECCODES_HAVE_STRING_H )
check_include_files( sys/types.h   ECCODES_HAVE_SYS_TYPES_H )
check_include_files( sys/stat.h    ECCODES_HAVE_SYS_STAT_H )
check_include_files( fcntl.h       ECCODES_HAVE_FCNTL_H )
check_include_files( unistd.h      ECCODES_HAVE_UNISTD_H )

check_symbol_exists( fseeko          "stdio.h"    ECCODES_HAVE_FSEEKO )
check_symbol_exists( posix_memalign  "stdlib.h"   ECCODES_HAVE_POSIX_MEMALIGN )
check_symbol_exists( fmemopen        "stdio.h"    ECCODES_HAVE_FMEMOPEN )
check_symbol_exists( funopen         "stdio.h"    ECCODES_HAVE_FUNOPEN )
check_symbol_exists( realpath        "stdlib.h"   ECCODES_HAVE_REALPATH )
check_symbol_exists( fsync           "unistd.h"   ECCODES_HAVE_FSYNC)
check_symbol_exists( fdatasync       "unistd.h"   ECCODES_HAVE_FDATASYNC)

check_c_source_compiles(
      " typedef int foo_t;
      static inline foo_t static_foo(void){return 0;}
      foo_t foo(void){return 0;}
      int main(int argc, char *argv[]){ return static_foo(); }
      " ECCODES_HAVE_C_INLINE
)

include(eccodes_test_endiness)
if( EC_OS_NAME MATCHES "windows" )
    include(eccodes_find_linux_utils)
endif()

ecbuild_debug("ECCODES_BIG_ENDIAN=${ECCODES_BIG_ENDIAN}")
ecbuild_debug("ECCODES_LITTLE_ENDIAN=${ECCODES_LITTLE_ENDIAN}")
ecbuild_info("Operating system=${CMAKE_SYSTEM} (${EC_OS_BITS} bits)")

# Only support 64 bit operating systems
if( NOT EC_OS_BITS EQUAL "64" )
    ecbuild_critical( "Operating system ${CMAKE_SYSTEM} (${EC_OS_BITS} bits) -- ecCodes only supports 64 bit platforms" )
endif()

###############################################################################
# some variables/options of this project

# ecbuild_add_cxx_flags("-Wno-write-strings" NO_FAIL)
# ecbuild_add_cxx_flags("-Wno-writable-strings" NO_FAIL)
# ecbuild_add_cxx_flags("-Wno-deprecated" NO_FAIL)

if( CMAKE_CXX_COMPILER_ID STREQUAL "Cray" )
    set(CMAKE_CXX_FLAGS "-hstd=c++11 ${CMAKE_CXX_FLAGS}")
endif()

ecbuild_add_option( FEATURE PRODUCT_GRIB
    DESCRIPTION "Support for the product GRIB"
    DEFAULT ON )
ecbuild_add_option( FEATURE PRODUCT_BUFR
    DESCRIPTION "Support for the product BUFR"
    DEFAULT ON )
if( NOT HAVE_PRODUCT_GRIB AND NOT HAVE_PRODUCT_BUFR )
    ecbuild_critical("Cannot disable both GRIB and BUFR! Please specify just one option")
endif()

ecbuild_add_option( FEATURE EXAMPLES
    DESCRIPTION "Build the examples"
    DEFAULT ON )

ecbuild_add_option( FEATURE BUILD_TOOLS
    DESCRIPTION "Build the command line tools"
    DEFAULT ON )

ecbuild_add_option( FEATURE GEOGRAPHY
    DESCRIPTION "Support for Geoiterator and nearest neighbour"
    DEFAULT ON )

ecbuild_add_option( FEATURE ECKIT_GEO
    DESCRIPTION "Support for Geoiterator and nearest neighbour (additional backend)"
    CONDITION ENABLE_GEOGRAPHY
    DEFAULT OFF )

if( eccodes_HAVE_ECKIT_GEO AND NOT TARGET eckit_geo )
    ecbuild_find_package(NAME eckit VERSION 1.27 REQUIRED)
    if( NOT TARGET eckit_geo )
        ecbuild_critical("eckit has not been built with ECKIT_GEO enabled")
    endif()
endif()

ecbuild_add_option( FEATURE JPG
    DESCRIPTION "Support for JPG decoding/encoding"
    DEFAULT ON )
# Options related to JPG. The JasPer and OpenJPEG libraries
ecbuild_add_option( FEATURE JPG_LIBJASPER
    DESCRIPTION "Support for JPG decoding/encoding with the JasPer library"
    CONDITION ENABLE_JPG
    DEFAULT ON )
ecbuild_add_option( FEATURE JPG_LIBOPENJPEG
    DESCRIPTION "Support for JPG decoding/encoding with the OpenJPEG library"
    CONDITION ENABLE_JPG
    DEFAULT ON )

ecbuild_add_option( FEATURE PNG
    DESCRIPTION "Support for PNG decoding/encoding"
    DEFAULT OFF
    REQUIRED_PACKAGES PNG )

if( HAVE_PNG )
    set( HAVE_LIBPNG 1 ) # compatibility with autotools
    add_definitions( ${PNG_DEFINITIONS} )
else()
    set( HAVE_LIBPNG 0 )
endif()

ecbuild_add_option( FEATURE NETCDF
    DESCRIPTION "Support for GRIB to NetCDF conversion"
    DEFAULT ON
    REQUIRED_PACKAGES NetCDF
    NO_TPL )

find_package( AEC )
if(NOT DEFINED ENABLE_AEC AND NOT AEC_FOUND)
  ecbuild_critical("AEC library was not found.\n"
                   "AEC (Adaptive Entropy Coding) provides the WMO GRIB CCSDS compression and decompression of data. "
                   "This is highly recommended from ecCodes >= 2.25.0"
                   "\nTo force the build without it, use -DENABLE_AEC=OFF")
endif()
ecbuild_add_option( FEATURE AEC
    DESCRIPTION "Support for Adaptive Entropy Coding"
    DEFAULT ON
    CONDITION AEC_FOUND )

ecbuild_find_python( VERSION 3.6 NO_LIBS )
# find_package( NumPy )

## TODO REQUIRED_LANGUAGES Fortran
ecbuild_add_option( FEATURE FORTRAN
    DESCRIPTION "Build the ecCodes Fortran interface"
    DEFAULT ON )

# TODO Remove this after REQUIRED_LANGUAGES
if( ENABLE_FORTRAN )
    # will set EC_HAVE_FORTRAN with the result
    set( EC_HAVE_FORTRAN 0 )
    ecbuild_enable_fortran( MODULE_DIRECTORY ${PROJECT_BINARY_DIR}/fortran/modules )
    set( HAVE_FORTRAN ${EC_HAVE_FORTRAN} )
else()
    set( HAVE_FORTRAN 0 )
endif()

# memfs requires only Python executable and not its libraries
ecbuild_add_option( FEATURE MEMFS
    DESCRIPTION "Memory based access to definitions/samples"
    DEFAULT OFF
    REQUIRED_PACKAGES Python3 )

#if( HAVE_MEMFS AND "${CMAKE_C_COMPILER_ID}" STREQUAL "Cray")
#  set( HAVE_MEMFS OFF )
#  ecbuild_warn("MEMFS not supported with Cray C compiler")
#endif()

if(HAVE_MEMFS)
  set( _will_install_defs_samples OFF )
else()
  set( _will_install_defs_samples ON )
endif()


# controls installation of files in definitions/ -- note that it still creates the symlinks in the build dir
# by default, if memfs is available, then we don't need to install definitions
ecbuild_add_option( FEATURE INSTALL_ECCODES_DEFINITIONS
    DESCRIPTION "Install the ecCodes definitions"
    DEFAULT ${_will_install_defs_samples} )

# controls installation of files in samples/ and ifs_samples/ -- note that it still creates the symlinks in the build dir
# by default, if memfs is available, then we don't need to install samples
ecbuild_add_option( FEATURE INSTALL_ECCODES_SAMPLES
    DESCRIPTION "Install the ecCodes samples, including IFS samples"
    DEFAULT ${_will_install_defs_samples} )

# advanced options (not visible in cmake-gui )

ecbuild_add_option( FEATURE MEMORY_MANAGEMENT   DESCRIPTION "Enable memory management" DEFAULT OFF ADVANCED )
ecbuild_add_option( FEATURE ALIGN_MEMORY        DESCRIPTION "Enable memory alignment"  DEFAULT OFF ADVANCED )
ecbuild_add_option( FEATURE TIMER               DESCRIPTION "Enable timer (deprecated)" DEFAULT OFF ADVANCED )
ecbuild_add_option( FEATURE ECCODES_THREADS     DESCRIPTION "Enable thread-safety using POSIX threads" DEFAULT OFF ADVANCED )
ecbuild_add_option( FEATURE ECCODES_OMP_THREADS DESCRIPTION "Enable thread-safety using OpenMP threads" DEFAULT OFF ADVANCED )
ecbuild_add_option( FEATURE EXTRA_TESTS         DESCRIPTION "Enable extended regression testing" DEFAULT OFF ADVANCED )

###############################################################################
# macro processing

set( ECCODES_EXTRA_LIBRARIES    "" )
set( ECCODES_EXTRA_INCLUDE_DIRS "" )
set( ECCODES_EXTRA_DEFINITIONS  "" )

find_package( CMath )
list( APPEND ECCODES_TPLS CMath )

### JPG support

set( HAVE_JPEG 0 )
set( HAVE_LIBJASPER 0 )
set( HAVE_LIBOPENJPEG 0 )

if( ENABLE_JPG )
    # Note: The function ecbuild_add_extra_search_paths is deprecated but we need it to find JasPer at ECMWF.
    #       It modifies CMAKE_PREFIX_PATH
    #       which can affect future package discovery if not undone by the caller.
    #       The current CMAKE_PREFIX_PATH is backed up as _CMAKE_PREFIX_PATH
    #
    #set(CMAKE_WARN_DEPRECATED OFF) # Suppress deprecation message
    #ecbuild_add_extra_search_paths( jasper )
    find_package( Jasper )
    #set(CMAKE_PREFIX_PATH ${_CMAKE_PREFIX_PATH})    # Restore CMAKE_PREFIX_PATH
    #set(CMAKE_WARN_DEPRECATED ON)  # Remove suppression

    find_package( OpenJPEG )

    if( JASPER_FOUND AND ENABLE_JPG_LIBJASPER )
        list( APPEND ECCODES_TPLS Jasper )
        set( HAVE_JPEG 1 )
        set( HAVE_LIBJASPER 1 )
        # Extract JasPer's major version number to enable conditional code. See ECC-396
        string(REGEX REPLACE "^([0-9]+)\\.[0-9]+\\.[0-9]+.*" "\\1" JASPER_VERSION_MAJOR "${JASPER_VERSION_STRING}")
    endif()

    if( OPENJPEG_FOUND AND ENABLE_JPG_LIBOPENJPEG )
        list( APPEND ECCODES_TPLS OpenJPEG )
        set( HAVE_JPEG 1 )
        set( HAVE_LIBOPENJPEG 1 )
    endif()

    ecbuild_info(" HAVE_JPEG=${HAVE_JPEG}")
    ecbuild_info(" HAVE_LIBJASPER=${HAVE_LIBJASPER}")
    ecbuild_info(" HAVE_LIBOPENJPEG=${HAVE_LIBOPENJPEG}")

endif()


###############################################################################
# other options

set( IS_BIG_ENDIAN 0 )
if( ECCODES_BIG_ENDIAN )
    set( IS_BIG_ENDIAN 1 )
endif()

set( MANAGE_MEM 0 )
if( ENABLE_MEMORY_MANAGEMENT )
    set( MANAGE_MEM 1 )
endif()

set( CMAKE_THREAD_PREFER_PTHREAD 1 ) # find thread library, but prefer pthreads
find_package(Threads REQUIRED)

# debug
ecbuild_info(" CMAKE_THREAD_LIBS_INIT=${CMAKE_THREAD_LIBS_INIT}")
ecbuild_info(" CMAKE_USE_PTHREADS_INIT=${CMAKE_USE_PTHREADS_INIT}")
ecbuild_info(" HAVE_ECCODES_THREADS=${HAVE_ECCODES_THREADS}")


set( GRIB_PTHREADS 0 )
set( GRIB_OMP_THREADS 0 )
set( GRIB_LINUX_PTHREADS 0 )
#if( HAVE_ECCODES_THREADS AND CMAKE_THREAD_LIBS_INIT )
if( HAVE_ECCODES_THREADS )
    if( NOT ${CMAKE_USE_PTHREADS_INIT} )
        ecbuild_critical("Pthreads is not supported on your system: thread library found=[${CMAKE_THREAD_LIBS_INIT}]")
    endif()
    set( GRIB_PTHREADS 1 )
    set( ECCODES_PTHREADS_LIBRARIES Threads::Threads ) # ECC-1268
    if( ${CMAKE_SYSTEM_NAME} MATCHES "Linux" )
        set( GRIB_LINUX_PTHREADS 1 )
    endif()
elseif(HAVE_ECCODES_OMP_THREADS)
    ecbuild_enable_omp()
    set( GRIB_OMP_THREADS 1 )
endif()

# Cannot have both options
if( HAVE_ECCODES_THREADS AND HAVE_ECCODES_OMP_THREADS )
    ecbuild_critical("Cannot enable both POSIX threads and OpenMP! Please specify just one option")
endif()

ecbuild_info(" POSIX THREADS = ${GRIB_PTHREADS}")
ecbuild_info(" OpenMP THREADS= ${GRIB_OMP_THREADS}")

set( GRIB_MEM_ALIGN 0 )
if( ENABLE_ALIGN_MEMORY )
  set( GRIB_MEM_ALIGN 1 )
endif()

# fix for #if IEEE_LE or IEE_BE instead of #ifdef

if( IEEE_BE )
    set( IEEE_LE 0 )
endif()

if( IEEE_LE )
    set( IEEE_BE 0 )
endif()

set( ECCODES_ON_WINDOWS 0 )

=== samples/CMakeLists.txt ===
file( GLOB samples_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*.tmpl" )

if(HAVE_INSTALL_ECCODES_SAMPLES)
    install( FILES ${samples_files}
             DESTINATION ${ECCODES_SAMPLES_SUFF}
             PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ )
endif()

foreach( tmpl ${samples_files} )
    list( APPEND ECCODES_SAMPLES_FILES ${CMAKE_CURRENT_SOURCE_DIR}/${tmpl} )
endforeach()

set( ECCODES_SAMPLES_DIR   ${CMAKE_CURRENT_SOURCE_DIR} PARENT_SCOPE )
set( ECCODES_SAMPLES_FILES ${ECCODES_SAMPLES_FILES}    PARENT_SCOPE )

# link to the samples in the build directory. See GRIB-786
file( MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/${INSTALL_DATA_DIR} )
if( NOT EXISTS "${CMAKE_BINARY_DIR}/${ECCODES_SAMPLES_SUFF}" )
  execute_process( COMMAND "${CMAKE_COMMAND}" "-E" "create_symlink"
    "${CMAKE_CURRENT_SOURCE_DIR}"
    "${CMAKE_BINARY_DIR}/${ECCODES_SAMPLES_SUFF}" )
endif()

=== tests/CMakeLists.txt ===
# tests/CMakeLists.txt
#
# Configure the file which all CMake tests will include
configure_file( include.ctest.sh.in  include.ctest.sh @ONLY )

execute_process( COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/utils.sh   ${CMAKE_CURRENT_BINARY_DIR} )
execute_process( COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/number_compare.pl ${CMAKE_CURRENT_BINARY_DIR} )

# Build the executables used by test scripts
################################################
list(APPEND test_c_bins
    list_codetable_flagtable_keys
    wmo_read_bufr_from_file
    wmo_read_gts_from_file
    wmo_read_any_from_file
    wmo_read_any_from_stream
    grib_bpv_limit
    grib_double_cmp
    read_any
    julian
    grib_update_sections_lengths
    grib_indexing
    grib_fieldset
    grib_multi_from_message
    grib_clone_headers_only
    grib_read_index
    grib_set_large_message_fail
    unit_tests
    bufr_keys_iter
    grib_keys_iter
    grib_keys_iter_skip
    grib_geo_iter
    grib_nearest_test
    grib_util_set_spec
    grib_util_set_spec2
    grib_check_param_concepts
    grib_local_MeteoFrance
    grib_2nd_order_numValues
    grib_optimize_scaling
    grib_optimize_scaling_sh
    grib_set_force
    grib_run_length_packing
    grib_partial_message
    grib_ecc-386
    grib_ecc-1467
    grib_ecc-1431
    grib_ecc-1433
    grib_ecc-1764
    grib_ecc-2005
    grib_ecc-2019
    grib_ecc-2034
    grib_ecc-2045
    bufr_ecc-517
    bufr_ecc-1288
    bufr_ecc-2011
    bufr_get_element
    bufr_extract_headers
    bufr_check_descriptors
    bufr_coordinate_descriptors
    codes_new_from_samples
    codes_dump_action_tree
    codes_set_samples_path
    codes_compare_keys
    codes_dump_content
    codes_codetable
    codes_get_string
    grib_sh_ieee64
    grib_set_bytes
    grib_copy_message
    grib_packing_order
    grib_unpack_subarray
    grib_sh_imag
    grib_spectral
    grib_lam_bf
    grib_lam_gp)


foreach( tool ${test_c_bins} )
    # here we use the fact that each tool has only one C file that matches its name
    ecbuild_add_executable( TARGET    ${tool}
                            NOINSTALL
                            SOURCES   ${tool}.cc
                            LIBS      eccodes )
endforeach()


# Now add each test (shell scripts)
#################################################
if( HAVE_BUILD_TOOLS )

    # These tests do not require any data downloads
    # and are generally quick
    list(APPEND tests_basic
        codes_info
        codes_deprecated
        unit_tests
        julian
        grib_dump_samples
        bufr_dump_samples
        bufr_check_descriptors
        definitions
        grib2_version
        grib_accessors
        grib_calendar
        grib_md5
        grib_cfNames
        grib_packing_order
        filter_substr
        filter_contains
        filter_size
        filter_is_one_of
        filter_is_in_list
        filter_transient_darray
        grib_ecpoint
        grib_s2s
        grib_fire
        grib_mtg2_switch
        grib_generalised_tiles
        # grib_true_imagery
        grib2_wave_spectra
        grib2_probability
        grib_suppressed
        grib_destine_mars_keys
        grib_2nd_order_numValues
        grib_ecc-136
        grib_ecc-530
        grib_ecc-922
        grib_ecc-966
        grib_ecc-967
        grib_ecc-1150
        grib_ecc-1053
        grib_ecc-1065
        grib_ecc-1167
        grib_ecc-1170
        grib_ecc-1195
        grib_ecc-1212
        grib_ecc-1230
        grib_ecc-1258
        grib_ecc-1260
        grib_ecc-1261
        grib_ecc-1271
        grib_ecc-1315
        grib_ecc-1322
        grib_ecc-1319
        grib_ecc-1406
        grib_ecc-1440
        grib_ecc-1560
        grib_ecc-1571
        grib_ecc-1654
        grib_ecc-1671
        grib_ecc-1708
        grib_ecc-1766
        grib_ecc-1829
        bufr_ecc-1028
        bufr_ecc-1195
        bufr_ecc-1259
        bufr_ecc-1290
        bufr_ecc-1304
        bufr_ecc-1347
        bufr_ecc-1395
        bufr_ecc-1840
        bufr_json_samples
        bufr_ecc-359
        bufr_ecc-517
        bufr_ecc-2011
        grib_efas
        grib_sh_imag
        grib_spectral
        grib_levtype
        grib_typeOfLevel
        grib2_product_templates
        grib_grid_unstructured
        grib_grid_lambert_conformal
        grib_grid_polar_stereographic
        grib_grid_healpix
        grib_g1day_of_the_year_date
    )

    # These tests require data downloads
    # and/or take much longer
    list(APPEND tests_extra
        grib_isGridded_isSpectral
        grib_data_quality_checks
        grib_check_message_validity
        grib_update_sections_lengths
        grib_units_bias_factor
        grib_set_large_message_fail
        grib_g1monthlydate
        grib_g1fcperiod
        grib_bpv_limit
        grib_complex
        grib_double_cmp
        grib_element
        grib_change_packing
        grib_run_length_packing
        grib_grid_space_view
        grib_partial_message
        grib_true_imagery
        grib_headers_only
        grib_uerra
        grib_unpack_subarray
        grib_count
        grib_clone_headers_only
        grib_ifsParam
        filter_dump_content
        wmo_read_bufr_from_file
        wmo_read_gts_from_file
        wmo_read_any_from_file
        wmo_read_any_from_stream
        bufr_templates
        bufr_rdbSubTypes
        bufr_dump_data
        bufr_dump_descriptors
        bufr_coordinate_descriptors
        bufr_dump_subset
        bufr_dump_decode_filter
        bufr_dump_encode_filter
        bufrdc_desc_ref
        bufrdc_ref
        bufr_compare
        bufr_copy
        bufr_count
        bufr_get
        bufr_operators
        bufr_filter_misc
        bufr_filter_datetime
        bufr_filter_fail
        bufr_filter_extract_subsets
        bufr_filter_extract_datetime
        bufr_filter_extract_area
        bufr_filter_unpack_pack
        bufr_filter_skipExtraKeyAttributes
        bufr_indexing
        bufr_json_data
        bufr_ls
        bufr_ls_json
        bufr_change_edition
        bufr_keys_iter
        grib_keys_iter
        grib_keys_iter_skip
        grib_geo_iter
        grib_to_json
        grib_to_ppm
        grib_list_keys
        grib_histogram
        bufr_get_element
        bufr_wmo_tables
        bufr_extract_headers
        extract_offsets
        bufr_ecc-147
        bufr_ecc-389
        bufr_ecc-673
        bufr_ecc-428
        bufr_ecc-286
        bufr_ecc-288
        bufr_ecc-313
        bufr_ecc-616
        bufr_ecc-680
        bufr_ecc-686
        bufr_ecc-690
        bufr_ecc-379
        bufr_ecc-393
        bufr_ecc-433
        bufr_ecc-750
        bufr_ecc-765
        bufr_ecc-875
        bufr_ecc-887
        bufr_ecc-1187
        bufr_ecc-1305
        bufr_ecc-1476
        bufr_ecc-1623
        bufr_ecc-1785
        bufr_ecc-1958
        bufr_ecc-1938
        bufr_ecc-2030
        bufr_ecc-2037
        grib_488
        grib_ecc-490
        grib_ecc-756
        grib_ecc-806
        grib_ecc-873
        grib_ecc-600
        grib_ecc-923
        grib_ecc-979
        grib_ecc-984
        grib_ecc-1000
        grib_ecc-1001
        grib_ecc-1030
        grib_ecc-1364
        grib_ecc-1397
        grib_ecc-1425
        grib_ecc-1467
        grib_ecc-1764
        grib_ecc-1792
        grib_ecc-1806
        #grib_ecc-1898
        grib_ecc-1907
        grib_ecc-1941
        grib_ecc-1942
        grib_ecc-2002
        grib_ecc-2005
        grib_ecc-2006
        grib_ecc-2013
        grib_ecc-2019
        grib_ecc-2034
        grib_ecc-2045
        grib_ecc-2050
        grib_ecc-2052
        grib_modelName
        grib_sub_hourly
        grib_set_bytes
        grib_set_force
        bufr_ecc-556
        codes_assert
        codes_ecc-1698
        codes_ecc-1929
        codes_get_string
        codes_codetable
        gts_get
        gts_ls
        gts_count
        gts_compare
        gts_dump
        wrap
        hdf5
        taf
        pseudo_diag
        metar_ls
        metar_filter
        metar_get
        metar_dump
        metar_compare
        bufr_set
        grib_ieee
        grib1_gds_not_present
        grib_sh_ieee64
        grib_optimize_scaling
        grib_optimize_scaling_sh
        grib_lam_bf
        grib_lam_gp
        grib1to2
        grib2to1
        grib1to3
        grib2to3
        grib2_templates
        grib2_chemicals_aerosols
        grib3_templates
        grib_bad
        grib_ls
        grib_ls_json
        grib_filter
        grib_filter_fail
        grib_multi
        grib_nearest_test
        pseudo_budg
        grib_gridType
        grib_gridSpec
        grib_fieldset
        grib_octahedral
        grib_grid_mercator
        grib_global
        grib_concept
        grib_copy_message
        grib_decimalPrecision
        grib_bitsPerValue
        grib_get_fail
        grib_missing
        grib_local_ECMWF
        grib_step
        grib_set
        grib_set_fail
        grib_iterator
        grib_iterator_fail
        grib_proj_string
        grib_compare
        grib_copy
        grib_level
        grib_indexing
        grib_bitmap
        grib_secondary_bitmap
        grib_list
        grib_second_order
        grib_multi_from_message
        grib_change_scanning
        grib_statistics
        read_any
        codes_new_from_samples
        codes_dump_action_tree
        codes_set_samples_path
        codes_compare_keys
        codes_dump_content
        codes_to_double
        grib_dump
        grib_dump_debug
        grib_dump_json
        grib_local_MeteoFrance
        grib_local_NCEP
        grib_neg_fctime
        codes_split_file
        grib_mars_keys1
        grib_mars_keys2)

    if( HAVE_AEC AND ENABLE_EXTRA_TESTS )
        list(APPEND tests_extra grib_ecc-1431)
        list(APPEND tests_extra grib_ecc-1433)
    endif()
    if( HAVE_FORTRAN AND ENABLE_EXTRA_TESTS )
        list(APPEND tests_extra bufr_dump_encode_fortran)
        list(APPEND tests_extra bufr_dump_decode_fortran)
    endif()
    if( ENABLE_EXTRA_TESTS )
        list(APPEND tests_extra grib_util_set_spec)
        list(APPEND tests_extra grib_util_set_spec2)
        list(APPEND tests_extra grib_padding)
        list(APPEND tests_extra grib_tigge_conversions1)
        list(APPEND tests_extra grib_tigge_conversions2)
        list(APPEND tests_extra bufr_dump_encode_C)
        list(APPEND tests_extra bufr_dump_decode_C)
        list(APPEND tests_extra bufr_dump_encode_python)
        list(APPEND tests_extra bufr_dump_decode_python)
        list(APPEND tests_extra list_codetable_flagtable_keys)
    endif()

    # These tests do not require any data downloads
    foreach( test ${tests_basic} )
        ecbuild_add_test( TARGET  eccodes_t_${test}
                          TYPE    SCRIPT
                          LABELS  "sanity"
                          COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/${test}.sh )
    endforeach()
    ecbuild_add_test( TARGET eccodes_t_grib_check_gaussian_grids
                      TYPE SCRIPT
                      CONDITION ECCODES_INSTALL_EXTRA_TOOLS AND ENABLE_EXTRA_TESTS
                      COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/grib_check_gaussian_grids.sh
                      TEST_DEPENDS eccodes_download_gribs )
    ecbuild_add_test( TARGET eccodes_t_grib_repair
                      TYPE SCRIPT
                      CONDITION ECCODES_INSTALL_EXTRA_TOOLS AND ENABLE_EXTRA_TESTS
                      COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/grib_repair.sh
                      TEST_DEPENDS eccodes_download_gribs )


    # Note: making the test dependent on the grib files (with DEPENDS)
    #       means they will be downloaded at "make" time
    #       rather than when you do "ctest". Use TEST_DEPENDS instead
    foreach( test ${tests_extra} )
        ecbuild_add_test( TARGET eccodes_t_${test}
                      TYPE SCRIPT
                      CONDITION ENABLE_EXTRA_TESTS

=== examples/C/CMakeLists.txt ===
# examples/C/CMakeLists.txt

# Configure the file which all CMake tests will include
configure_file( include.ctest.sh.in  include.ctest.sh  @ONLY )


# Build the executables used by test scripts
#############################################
list( APPEND test_bins
      grib_nearest
      grib_set_bitmap
      grib_iterator
      grib_get_keys
      grib_print_data
      grib_set_keys
      grib_index
      grib_set_missing
      grib_keys_iterator
      grib_set_data
      grib_nearest_multiple
      grib_multi
      grib_multi_write
      grib_precision
      grib_set_pv
      grib_list
      grib_get_data
      grib_sections_copy
      grib_copy_keys
      grib_clone
      grib_copy_message
      grib_ensemble_index
      bufr_copy_data
      bufr_attributes
      bufr_clone
      bufr_expanded
      bufr_get_keys
      bufr_get_string_array
      bufr_keys_iterator
      bufr_missing
      bufr_read_header
      bufr_read_scatterometer
      bufr_read_synop
      bufr_read_temp
      bufr_read_tempf
      bufr_set_keys
      bufr_subset
      grib_values_check
      multi2
      large_grib1
      get_product_kind)

foreach( tool ${test_bins} )
    ecbuild_add_executable( TARGET    c_${tool}
                            NOINSTALL
                            SOURCES   ${tool}.c
                            LIBS      eccodes )
endforeach()

# Now add each test (shell scripts)
####################################
if( HAVE_BUILD_TOOLS )
    # Command line tools are available
    list(APPEND tests_sanity
         grib_set_data
         large_grib1
         grib_sections_copy
         grib_copy_keys
         get_product_kind_samples)
    list(APPEND tests_extra
       grib_iterator
       grib_get_keys
       grib_print_data
       grib_set_keys
       grib_keys_iterator
       grib_multi_write
       grib_precision
       grib_clone
       grib_copy_message
       grib_ensemble_index
       grib_index
       grib_set_pv
       grib_set_bitmap
       grib_list
       grib_get_data
       grib_nearest
       grib_nearest_multiple
       grib_multi
       grib_set_missing
       grib_values_check
       bufr_attributes
       bufr_copy_data
       bufr_clone
       bufr_expanded
       bufr_get_keys
       bufr_get_string_array
       bufr_keys_iterator
       bufr_missing
       bufr_read_header
       bufr_read_scatterometer
       bufr_read_synop
       bufr_read_temp
       bufr_read_tempf
       bufr_set_keys
       bufr_subset
       get_product_kind)
else()
    # No command line tools
    list(APPEND tests_sanity
        grib_set_data
        get_product_kind_samples)
    list(APPEND tests_extra
       grib_iterator
       grib_get_keys
       grib_print_data
       grib_set_keys
       grib_keys_iterator
       grib_precision
       grib_ensemble_index
       grib_set_pv
       grib_list
       grib_get_data
       grib_nearest_multiple
       grib_multi
       grib_set_missing
       bufr_attributes
       bufr_expanded
       bufr_get_keys
       bufr_get_string_array
       bufr_keys_iterator
       bufr_missing
       bufr_read_header
       bufr_read_scatterometer
       bufr_read_synop
       bufr_read_temp
       bufr_read_tempf
       bufr_set_keys
       bufr_subset
       get_product_kind)
endif()

foreach( test ${tests_sanity} )
        ecbuild_add_test( TARGET       eccodes_c_${test}
                          TYPE         SCRIPT
                          LABELS       "sanity"
                          COMMAND      ${CMAKE_CURRENT_SOURCE_DIR}/${test}.sh )
endforeach()
foreach( test ${tests_extra} )
        ecbuild_add_test( TARGET       eccodes_c_${test}
                          TYPE         SCRIPT
                          CONDITION    ENABLE_EXTRA_TESTS
                          COMMAND      ${CMAKE_CURRENT_SOURCE_DIR}/${test}.sh
                          TEST_DEPENDS eccodes_download_gribs eccodes_download_bufrs eccodes_download_bufr_refs )
endforeach()

# Tests which are conditional
#############################
if( ENABLE_EXTRA_TESTS AND HAVE_ECCODES_THREADS )
    # For POSIX threads
    list(APPEND pthread_tests grib_pthreads bufr_pthreads)
    foreach( test ${pthread_tests} )
        ecbuild_add_executable( TARGET    c_${test}
                                NOINSTALL
                                SOURCES   ${test}.c
                                LIBS      eccodes ${CMAKE_THREAD_LIBS_INIT} )
        ecbuild_add_test( TARGET       eccodes_c_${test}
                          TYPE         SCRIPT
                          COMMAND      ${CMAKE_CURRENT_SOURCE_DIR}/${test}.sh
                          TEST_DEPENDS eccodes_download_gribs eccodes_download_bufrs )
    endforeach()
endif()

# Tests with no script
######################
ecbuild_add_test(
    TARGET    eccodes_c_new_sample
    SOURCES   new_sample.c
    LIBS      eccodes
    ARGS      "out.grib"
    ENVIRONMENT "ECCODES_SAMPLES_PATH=${PROJECT_SOURCE_DIR}/samples" "ECCODES_DEFINITION_PATH=${PROJECT_SOURCE_DIR}/definitions"
)

=== examples/F90/CMakeLists.txt ===
# examples/F90/CMakeLists.txt

# Configure the file which all CMake tests will include
configure_file( include.ctest.sh.in  include.ctest.sh  @ONLY )

list( APPEND test_bins
    bufr_attributes
    bufr_clone
    bufr_copy_data
    bufr_copy_keys
    bufr_copy_message
    bufr_ecc-1019
    bufr_ecc-1284
    bufr_expanded
    bufr_get_keys
    bufr_get_string_array
    bufr_keys_iterator
    bufr_read_header
    bufr_read_scatterometer
    bufr_read_synop
    bufr_read_temp
    bufr_read_tempf
    bufr_read_tropical_cyclone
    bufr_set_keys
    bufr_subset
    codes_datetime_julian
    codes_dump
    codes_ecc-1392
    codes_f90_misc
    codes_load_file
    codes_scan_file
    codes_set_paths
    get_native_type
    get_product_kind
    grib_clone
    grib_copy_message
    grib_copy_namespace
    grib_count_messages
    grib_count_messages_multi
    grib_ecc-1316
    grib_ecc-671
    grib_elements
    grib_get_data
    grib_get_data_real4
    grib_get_keys
    grib_get_pl
    grib_get_pv
    grib_get_set_uuid
    grib_index
    grib_keys_iterator
    grib_keys_iterator_skip
    grib_multi
    grib_multi_write
    grib_nearest
    grib_nearest_four_single
    grib_nearest_single
    grib_precision
    grib_print_data
    grib_read_bytes
    grib_read_from_file
    grib_read_message
    grib_samples
    grib_sections_copy
    grib_set_bitmap
    grib_set_data
    grib_set_data_force
    grib_set_keys
    grib_set_missing
    grib_set_pv
    key_is_computed)

foreach( tool ${test_bins} )
    ecbuild_add_executable( TARGET          f_${tool}
                            NOINSTALL
                            SOURCES         ${tool}.f90
                            LINKER_LANGUAGE Fortran
                            CONDITION       HAVE_FORTRAN
                            LIBS            eccodes_f90 eccodes )
endforeach()

# Add all the tests
####################
if( HAVE_BUILD_TOOLS )
    list( APPEND tests_sanity
          codes_ecc-1392
          codes_datetime_julian
          codes_set_paths
          codes_f90_misc
          grib_set_pv
          grib_set_data
          grib_set_data_force
          bufr_ecc-1284
          bufr_ecc-1019
          get_native_type
          key_is_computed
          grib_ecc-671 )
    list( APPEND tests_extra
          grib_index
          codes_dump
          codes_scan_file
          codes_load_file
          grib_copy_message
          grib_sections_copy
          bufr_copy_message
          grib_get_keys
          grib_get_data
          grib_get_data_real4
          grib_get_pl
          grib_get_pv
          grib_keys_iterator
          grib_keys_iterator_skip
          grib_multi_write
          grib_multi
          grib_elements
          grib_nearest
          grib_nearest_single
          grib_nearest_four_single
          grib_precision
          grib_print_data
          grib_set_keys
          grib_set_bitmap
          grib_set_missing
          grib_samples
          grib_count_messages
          grib_count_messages_multi
          grib_copy_namespace
          grib_read_message
          grib_read_from_file
          grib_read_bytes
          grib_get_set_uuid
          grib_clone
          grib_ecc-1316
          bufr_attributes
          bufr_clone
          bufr_expanded
          bufr_get_keys
          bufr_get_string_array
          bufr_keys_iterator
          bufr_read_header
          bufr_read_scatterometer
          bufr_read_synop
          bufr_read_temp
          bufr_read_tempf
          bufr_read_tropical_cyclone
          bufr_set_keys
          bufr_copy_keys
          bufr_subset
          get_product_kind )
else()
    # No command line tools
    list( APPEND tests_sanity
          grib_set_pv
          grib_set_data
          grib_set_data_force
          codes_set_paths
          codes_f90_misc
          get_native_type
          key_is_computed
          grib_ecc-671 )
    list( APPEND tests_extra
          grib_index
          grib_get_keys
          grib_get_data
          grib_get_pl
          grib_get_pv
          grib_keys_iterator
          grib_keys_iterator_skip
          grib_multi
          grib_nearest
          grib_elements
          grib_nearest_single
          grib_nearest_four_single
          grib_precision
          grib_print_data
          grib_set_missing
          grib_samples
          grib_count_messages
          grib_count_messages_multi
          grib_read_from_file
          grib_clone
          bufr_attributes
          bufr_clone
          bufr_expanded
          bufr_get_keys
          bufr_get_string_array
          bufr_keys_iterator
          bufr_read_header
          bufr_read_scatterometer
          bufr_read_synop
          bufr_read_temp
          bufr_read_tempf
          bufr_read_tropical_cyclone
          bufr_set_keys
          bufr_subset
          get_product_kind )
endif()

foreach( atest ${tests_sanity} )
    ecbuild_add_test( TARGET          eccodes_f_${atest}
                      TYPE            SCRIPT
                      CONDITION       HAVE_FORTRAN
                      LABELS          "sanity"
                      RESOURCES       bufr_read_scatterometer_f.ref
                      COMMAND         ${CMAKE_CURRENT_SOURCE_DIR}/${atest}.sh )
endforeach()

if( HAVE_BUILD_TOOLS AND NOT CMAKE_CXX_COMPILER_ID MATCHES NVHPC )
      # Test which fails on Leonardo
      list( APPEND tests_extra bufr_copy_data )
endif()

foreach( atest ${tests_extra} )
    ecbuild_add_test( TARGET          eccodes_f_${atest}
                      CONDITION       HAVE_FORTRAN AND ENABLE_EXTRA_TESTS
                      RESOURCES       bufr_read_scatterometer_f.ref
                      COMMAND         ${CMAKE_CURRENT_SOURCE_DIR}/${atest}.sh
                      TEST_DEPENDS    eccodes_download_gribs eccodes_download_bufrs eccodes_download_bufr_refs )
endforeach()

# Test for CCSDS (AEC) packing
if( HAVE_BUILD_TOOLS AND HAVE_AEC AND HAVE_FORTRAN )
    ecbuild_add_executable( TARGET          f_grib_set_packing
                            NOINSTALL
                            SOURCES         grib_set_packing.f90
                            LINKER_LANGUAGE Fortran
                            LIBS            eccodes_f90 eccodes )

    ecbuild_add_test( TARGET   eccodes_f_grib_set_packing
                      COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/grib_set_packing.sh )
endif()

# Executables without a shell script
#ecbuild_add_executable( TARGET    f_new_from_file
#                        NOINSTALL
#                        SOURCES   new_from_file.f90
#                        CONDITION HAVE_FORTRAN
#                        LINKER_LANGUAGE Fortran
#                        LIBS      eccodes_f90 eccodes )
ecbuild_add_executable( TARGET    f_grib_set_gvc
                        NOINSTALL
                        SOURCES   grib_set_gvc.f90
                        CONDITION HAVE_FORTRAN
                        LINKER_LANGUAGE Fortran
                        LIBS      eccodes_f90 eccodes )
ecbuild_add_executable( TARGET    f_grib_print_data_static
                        NOINSTALL
                        SOURCES   grib_print_data_static.f90
                        CONDITION HAVE_FORTRAN
                        LINKER_LANGUAGE Fortran
                        LIBS      eccodes_f90 eccodes )


# # Note extra dependency
# ecbuild_add_test( TARGET eccodes_f_set_test
#                   TYPE SCRIPT
#                   DEPENDS set_gvc set
#                   COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/set.sh
# )

=== ifs_samples/grib1_mlgrib2_ccsds/CMakeLists.txt ===
set( _basedir grib1_mlgrib2_ccsds )
set( _destination_install ${ECCODES_IFS_SAMPLES_SUFF}/${_basedir} )
set( _destination_build   ${CMAKE_BINARY_DIR}/${ECCODES_IFS_SAMPLES_SUFF}/${_basedir} )

list( APPEND ifs_samples_${_basedir}
      ${CMAKE_CURRENT_SOURCE_DIR}/gg_ml.tmpl
      ${CMAKE_CURRENT_SOURCE_DIR}/gg_sfc_grib2.tmpl
      ${CMAKE_CURRENT_SOURCE_DIR}/gg_sfc.tmpl
      ${CMAKE_CURRENT_SOURCE_DIR}/sh_ml.tmpl
      ${CMAKE_CURRENT_SOURCE_DIR}/sh_sfc.tmpl )

install_samples( ifs_samples_${_basedir} ${_destination_install} ${_destination_build} )

=== ifs_samples/grib1_mlgrib2_ieee32/CMakeLists.txt ===
set( _basedir grib1_mlgrib2_ieee32 )
set( _destination_install ${CMAKE_INSTALL_PREFIX}/${ECCODES_IFS_SAMPLES_SUFF}/${_basedir} )
set( _destination_build   ${CMAKE_BINARY_DIR}/${ECCODES_IFS_SAMPLES_SUFF}/${_basedir} )

list( APPEND ifs_samples_${_basedir}
      ${CMAKE_CURRENT_SOURCE_DIR}/gg_ml.tmpl
      ${CMAKE_CURRENT_SOURCE_DIR}/gg_sfc.tmpl
      ${CMAKE_CURRENT_SOURCE_DIR}/sh_ml.tmpl
      ${CMAKE_CURRENT_SOURCE_DIR}/sh_sfc.tmpl )

install_samples( ifs_samples_${_basedir} ${_destination_install} ${_destination_build} )

=== src/eccodes/CMakeLists.txt ===
#
# (C) Copyright 2005- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
#
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

list( APPEND eccodes_src_files
    step_unit.cc
    step.cc
    step_utilities.cc
    grib_api.h
    eccodes.h

    action/Action.cc
    action/Alias.cc
    action/Gen.cc
    action/If.cc
    action/Switch.cc
    action/Section.cc
    action/List.cc
    action/While.cc
    action/Put.cc
    action/Meta.cc
    action/Remove.cc
    action/Rename.cc
    action/Assert.cc
    action/Template.cc
    action/Trigger.cc
    action/When.cc
    action/Concept.cc
    action/HashArray.cc
    action/Set.cc
    action/SetSarray.cc
    action/SetDarray.cc
    action/Noop.cc
    action/Write.cc
    action/Print.cc
    action/Close.cc
    action/Variable.cc
    action/Modify.cc
    action/TransientDarray.cc
    action/SetMissing.cc

    eccodes.cc
    grib_concept.cc
    grib_hash_array.cc
    grib_bufr_descriptor.cc
    grib_bufr_descriptors_array.cc
    grib_darray.cc
    grib_sarray.cc
    grib_oarray.cc
    grib_vdarray.cc
    grib_vsarray.cc
    grib_iarray.cc
    grib_viarray.cc
    codes_memfs.cc

    accessor/grib_accessors_list.cc
    grib_accessor_class.cc

    accessor/Accessor.cc
    accessor/G1FcPeriod.cc
    accessor/G1EndOfIntervalMonthly.cc
    accessor/MarsParam.cc
    accessor/Gen.cc
    accessor/Ascii.cc
    accessor/Bit.cc
    accessor/Bitmap.cc
    accessor/Bits.cc
    accessor/BitsPerValue.cc
    accessor/BufrElementsTable.cc
    accessor/BufrDataArray.cc
    accessor/BufrDataElement.cc
    accessor/BufrGroup.cc
    accessor/BufrStringValues.cc
    accessor/PackBufrValues.cc
    accessor/UnpackBufrValues.cc
    accessor/Group.cc
    accessor/NonAlpha.cc
    accessor/G1Bitmap.cc
    accessor/G2Bitmap.cc
    accessor/Concept.cc
    accessor/HashArray.cc
    accessor/DecimalPrecision.cc
    accessor/DivDouble.cc
    accessor/MultDouble.cc
    accessor/BudgDate.cc
    accessor/ValidityDate.cc
    accessor/ValidityTime.cc
    accessor/Bytes.cc
    accessor/CfVarName.cc
    accessor/ChangeAlternativeRowScanning.cc
    accessor/ChangeScanningDirection.cc
    accessor/CheckInternalVersion.cc
    accessor/Codeflag.cc
    accessor/SmartTable.cc
    accessor/SmartTableColumn.cc
    accessor/Codetable.cc
    accessor/CodetableUnits.cc
    accessor/CodetableTitle.cc
    accessor/StepHumanReadable.cc
    accessor/CountFile.cc
    accessor/CountTotal.cc
    accessor/Double.cc
    accessor/Element.cc
    accessor/Evaluate.cc
    accessor/G1Date.cc
    accessor/G1MonthlyDate.cc
    accessor/LibraryVersion.cc
    accessor/When.cc
    accessor/G1VerificationDate.cc
    accessor/G1DayOfTheYearDate.cc
    accessor/G1HalfByteCodeflag.cc
    accessor/G1ForecastMonth.cc
    accessor/G1StepRange.cc
    accessor/G2StepRange.cc
    accessor/DataG22OrderPacking.cc
    accessor/MarsStep.cc
    accessor/MessageCopy.cc
    accessor/MessageIsValid.cc
    accessor/Dictionary.cc
    accessor/LatLonIncrement.cc
    accessor/G2Date.cc
    accessor/G2Level.cc
    accessor/G2EndStep.cc
    accessor/G2LatLon.cc
    accessor/G2Lon.cc
    accessor/GlobalGaussian.cc
    accessor/GaussianGridName.cc
    accessor/Getenv.cc
    accessor/GtsHeader.cc
    accessor/IfsParam.cc
    accessor/JulianDay.cc
    accessor/JulianDate.cc
    accessor/ClosestDate.cc
    accessor/LatLonValues.cc
    accessor/Latitudes.cc
    accessor/Longitudes.cc
    accessor/OffsetFile.cc
    accessor/Scale.cc
    accessor/FromScaleFactorScaledValue.cc
    accessor/G2BitmapPresent.cc
    accessor/IbmFloat.cc
    accessor/IeeeFloat.cc
    accessor/Constant.cc
    accessor/Iterator.cc
    accessor/Message.cc
    accessor/Nearest.cc
    accessor/Ksec1Expver.cc
    accessor/Label.cc
    accessor/Long.cc
    accessor/Lookup.cc
    accessor/OctahedralGaussian.cc
    accessor/OctetNumber.cc
    accessor/HeadersOnly.cc
    accessor/Padding.cc
    accessor/Pad.cc
    accessor/PadTo.cc
    accessor/PadToEven.cc
    accessor/PadToMultiple.cc
    accessor/SectionPadding.cc
    accessor/PackingType.cc
    accessor/SectionPointer.cc
    accessor/Position.cc
    accessor/Signed.cc
    accessor/SignedBits.cc
    accessor/Section.cc
    accessor/StepInUnits.cc
    accessor/OptimalStepUnits.cc
    accessor/SectionLength.cc
    accessor/G1MessageLength.cc
    accessor/G1Section4Length.cc
    accessor/Size.cc
    accessor/RdbTimeGuessDate.cc
    accessor/ScaleValues.cc
    accessor/OffsetValues.cc
    accessor/Sprintf.cc
    accessor/Round.cc
    accessor/SpectralTruncation.cc
    accessor/Time.cc
    accessor/Transient.cc
    accessor/Trim.cc
    accessor/TransientDarray.cc
    accessor/Values.cc
    accessor/SimplePackingError.cc
    accessor/DataSimplePacking.cc
    accessor/CountMissing.cc
    accessor/DataShPacked.cc
    accessor/DataShUnpacked.cc
    accessor/NumberOfValuesDataRawPacking.cc
    accessor/DataG1SimplePacking.cc
    accessor/DataG1ShSimplePacking.cc
    accessor/DataShSimplePacking.cc
    accessor/DataDummyField.cc
    accessor/Variable.cc
    accessor/SecondOrderBitsPerValue.cc
    accessor/DataG2SimplePacking.cc
    accessor/DataG2SimplePackingWithPreprocessing.cc
    accessor/DataG2ShSimplePacking.cc
    accessor/DataG2ComplexPacking.cc
    accessor/DataG1SecondOrderRowByRowPacking.cc
    accessor/DataG1SecondOrderConstantWidthPacking.cc
    accessor/DataG1SecondOrderGeneralPacking.cc
    accessor/DataG1SecondOrderGeneralExtendedPacking.cc
    accessor/G2Grid.cc
    accessor/UnexpandedDescriptors.cc
    accessor/ExpandedDescriptors.cc
    accessor/BufrdcExpandedDescriptors.cc
    accessor/DataApplyBitmap.cc
    accessor/DataApplyBoustrophedonic.cc
    accessor/DataApplyBoustrophedonicBitmap.cc
    accessor/DataSecondaryBitmap.cc
    accessor/DataG1SecondaryBitmap.cc
    accessor/DataG2SecondaryBitmap.cc
    accessor/DataJpeg2000Packing.cc
    accessor/DataPngPacking.cc
    accessor/DataCcsdsPacking.cc
    accessor/DataRawPacking.cc
    accessor/DataComplexPacking.cc
    accessor/DataG1ComplexPacking.cc
    accessor/GdsIsPresent.cc
    accessor/SelectStepTemplate.cc
    accessor/LocalDefinition.cc
    accessor/G2Eps.cc
    accessor/G2Aerosol.cc
    accessor/G2Chemical.cc
    accessor/G2ConceptDir.cc
    accessor/Mtg2SwitchDefault.cc
    accessor/G2MarsLabeling.cc
    accessor/Md5.cc
    accessor/ProjString.cc
    accessor/NumberOfPoints.cc
    accessor/Suppressed.cc
    accessor/NumberOfPointsGaussian.cc
    accessor/NumberOfValues.cc
    accessor/NumberOfCodedValues.cc
    accessor/G1NumberOfCodedValuesShComplex.cc
    accessor/G1NumberOfCodedValuesShSimple.cc
    accessor/Dirty.cc
    accessor/Statistics.cc
    accessor/StatisticsSpectral.cc
    accessor/Unsigned.cc
    accessor/UnsignedBits.cc
    accessor/Raw.cc
    accessor/BufrSimpleThinning.cc
    accessor/BufrExtractSubsets.cc
    accessor/BufrExtractAreaSubsets.cc
    accessor/BufrExtractDatetimeSubsets.cc
    accessor/Spd.cc
    accessor/Sum.cc
    accessor/ToInteger.cc
    accessor/ToDouble.cc
    accessor/ToString.cc
    accessor/Sexagesimal2Decimal.cc
    accessor/Vector.cc
    accessor/LongVector.cc
    accessor/AbstractVector.cc
    accessor/AbstractLongVector.cc
    accessor/ReferenceValueError.cc
    accessor/Uint16.cc
    accessor/Uint32.cc
    accessor/Uint32LittleEndian.cc
    accessor/Uint64.cc
    accessor/Uint64LittleEndian.cc
    accessor/Uint8.cc
    accessor/Blob.cc
    accessor/DataG2BifourierPacking.cc
    accessor/DataRunLengthPacking.cc
    accessor/GridSpec.cc
    accessor/G2ParamConceptFilename.cc

    grib_jasper_encoding.cc
    grib_openjpeg_encoding.cc
    grib_index.cc
    geo/grib_gaussian_reduced.cc
    grib_loader_from_handle.cc
    grib_bits.cc
    grib_ibmfloat.cc
    grib_ieeefloat.cc
    grib_memory.cc
    grib_buffer.cc

    dumper/Serialize.cc
    dumper/Debug.cc
    dumper/Default.cc
    dumper/BufrEncodeC.cc
    dumper/BufrEncodeFilter.cc
    dumper/BufrEncodeFortran.cc
    dumper/BufrEncodePython.cc
    dumper/BufrDecodeC.cc
    dumper/BufrDecodeFilter.cc
    dumper/BufrDecodeFortran.cc
    dumper/BufrDecodePython.cc
    dumper/BufrSimple.cc
    dumper/Json.cc
    dumper/GribEncodeC.cc
    dumper/Wmo.cc

    grib_context.cc
    grib_date.cc
    grib_fieldset.cc
    grib_filepool.cc
    geo/grib_geography.cc
    grib_handle.cc
    grib_hash_keys.cc
    grib_io.cc
    grib_trie.cc
    grib_trie_with_rank.cc
    grib_itrie.cc
    grib_rules.cc
    grib_keys_iterator.cc
    bufr_keys_iterator.cc
    grib_parse_utils.cc
    grib_query.cc
    grib_scaling.cc
    grib_templates.cc
    grib_dependency.cc
    grib_value.cc
    grib_errors.cc

    grib_arguments.cc

    expression/Expression.cc
    expression/Binop.cc
    expression/LogicalAnd.cc
    expression/LogicalOr.cc
    expression/IsInDict.cc
    expression/True.cc
    expression/StringCompare.cc
    expression/Unop.cc
    expression/Functor.cc
    expression/Accessor.cc
    expression/IsInList.cc
    expression/IsInteger.cc
    expression/Length.cc
    expression/Long.cc
    expression/Double.cc
    expression/String.cc
    expression/SubString.cc

    geo/nearest/Nearest.cc
    geo/nearest/Gen.cc
    geo/nearest/Healpix.cc
    geo/nearest/LambertAzimuthalEqualArea.cc
    geo/nearest/LambertConformal.cc
    geo/nearest/LatlonReduced.cc
    geo/nearest/Mercator.cc
    geo/nearest/PolarStereographic.cc
    geo/nearest/Reduced.cc
    geo/nearest/Regular.cc
    geo/nearest/SpaceView.cc

    geo/iterator/Iterator.cc
    geo/iterator/Gaussian.cc
    geo/iterator/GaussianReduced.cc
    geo/iterator/Gen.cc
    geo/iterator/Healpix.cc
    geo/iterator/LambertAzimuthalEqualArea.cc
    geo/iterator/LambertConformal.cc
    geo/iterator/Latlon.cc
    geo/iterator/LatlonReduced.cc
    geo/iterator/Mercator.cc
    geo/iterator/PolarStereographic.cc
    geo/iterator/Regular.cc
    geo/iterator/SpaceView.cc
    geo/iterator/Unstructured.cc

    codes_util.cc
    grib_util.cc
    bufr_util.cc
    string_util.cc
    functions.cc
    grib_accessor_class.h
    grib_accessor_factory.h
    grib_api_internal.h
    eccodes_prototypes.h
    grib_dumper_factory.cc
    grib_iterator_factory.cc
    grib_nearest_factory.cc
    grib_yacc.h
    md5_core.h
    md5_core.cc
    grib_optimize_decimal_factor.cc
    eccodes_windef.h
    # We ship our own generated lex/yacc C files
    grib_yacc.cc  grib_lex.cc )

list( APPEND eccodes_extra_src_files
    grib_bits_fast_big_endian.cc grib_bits_any_endian.cc
    grib_bits_fast_big_endian_vector.cc grib_bits_any_endian_vector.cc
    grib_bits_fast_big_endian_simple.cc grib_bits_any_endian_simple.cc
    grib_bits_fast_big_endian_omp.cc grib_bits_any_endian_omp.cc
    encode_double_array.cc
    grib_bits_ibmpow.cc
    grib_bits_ibmpow_opt.cc )

if(UNIX)
    ecbuild_get_date(eccodes_BUILD_DATE)
endif()
configure_file( grib_api_version.cc.in grib_api_version.cc @ONLY )
configure_file( eccodes_version.h.in eccodes_version.h @ONLY )

# We ship our own generated lex/yacc C files
#ecbuild_generate_yy(YYPREFIX  grib_yy
#                    YACC      griby
#                    LEX       gribl
#                    FLEX_FLAGS " "
#                    LEX_FLAGS  " "
#                    BISON_FLAGS "-y"
#                    YACC_FLAGS  "-y"
#                    DEPENDANT action.cc )

if( HAVE_MEMFS )
    list(APPEND ECCODES_EXTRA_LIBRARIES eccodes_memfs)
endif()

if( eccodes_HAVE_GEOGRAPHY AND eccodes_HAVE_ECKIT_GEO )
    list( APPEND eccodes_src_files
        geo/EckitMainInit.cc
        geo/EckitMainInit.h
        geo/GeoIterator.cc
        geo/GeoIterator.h
        geo/GribSpec.cc
        geo/GribSpec.h )
    list( APPEND ECCODES_EXTRA_LIBRARIES eckit_geo )
endif()

ecbuild_add_library( TARGET    eccodes
                     SOURCES   ${CMAKE_CURRENT_BINARY_DIR}/grib_api_version.cc

=== debian/changelog ===
eccodes (2.41.0-1build1) questing; urgency=medium

  * No-change rebuild for gfortran 15.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Sep 2025 14:27:05 +0200

eccodes (2.41.0-1) unstable; urgency=medium

  * Standards-Version: 4.7.2
  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 14 Apr 2025 19:16:24 +0100

=== debian/control ===
Source: eccodes
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  architecture-is-64-bit,
  dh-fortran-mod (>= 0.31),
  ecbuild (>= 3.7.0),
  libjpeg-dev, 
  libpng-dev, 
  flex, 
  bison, 
  quilt,
  swig, 
  doxygen,
  libboost-dev, 
  libhdf5-dev, 
  chrpath,
  libaec-dev,
  libnetcdf-dev,
  libopenjp2-7-dev
Build-Conflicts: libopenjpeg-dev, libeccodes-dev
Standards-Version: 4.7.2
Homepage: https://software.ecmwf.int/wiki/display/ECC/ecCodes+Home
Vcs-Browser: https://salsa.debian.org/science-team/eccodes.git
Vcs-Git: https://salsa.debian.org/science-team/eccodes.git -b debian/latest

Package: libeccodes0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libeccodes-data
Description: GRIB and BUFR enecoding/encoding software library
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 It is a replacement for the grib-api and emoslib libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeccodes-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: GRIB and BUFR enecoding/encoding software library - data
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 
Package: libeccodes-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Recommends: libeccodes-tools
Depends: libeccodes0 (= ${binary:Version}), 
  ${misc:Depends}, ${shlibs:Depends},  ${fortran:Depends},
  libaec-dev, libpng-dev, libjpeg-dev, zlib1g-dev
Description: GRIB and BUFR decoding/encoding software library (development)
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.
 
Package: libeccodes-tools
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GRIB decoding/encoding software (utilities)
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 This is a useful set of command line tools to give quick access to grib
 messages.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeccodes-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, libjs-jquery
Description: GRIB decoding/encoding software (documentation)
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 This provides the documentation for the library.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

=== debian/watch ===
version=3
https://confluence.ecmwf.int/display/ECC/Releases /download/attachments/45757960/eccodes\-(.+)\-Source\.tar\.gz\?api=v2
